﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Syncfusion.Windows.Automation.Linq;
using Syncfusion.Windows.Controls.Grid;
using System.Collections.Specialized;
using Syncfusion.Windows.Controls.Cells;
using Syncfusion.Windows.Shared;
using System.Collections;
using System.Text.RegularExpressions;
using Syncfusion.Windows.Tools.Controls;
using System.ComponentModel;
using System.Xml.Serialization;
using Syncfusion.Windows.Styles;
using System.Xml;
using System.Threading;

namespace GridControlSample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            grid.Model.RowCount = 10;
            grid.Model.ColumnCount = 10;
            grid.Model.HeaderRows = 1;
            grid.Model.HeaderColumns = 1;
            grid.Model.HeaderStyle.Background = new SolidColorBrush(Colors.WhiteSmoke);
            grid.Model.Options.ActivateCurrentCellBehavior = GridCellActivateAction.DblClickOnCell;

            grid.Model.QueryCellInfo += Model_QueryCellInfo;
            grid.Model.SelectionChanged += Model_SelectionChanged;
        }

        private void Model_SelectionChanged(object sender, GridSelectionChangedEventArgs e)
        {
            //Invalidate the corresponding Header rows and colums when selection is changed.
            grid.Model.InvalidateCell(GridRangeInfo.Cols(0, grid.Model.HeaderColumns - 1));
            grid.Model.InvalidateCell(GridRangeInfo.Rows(0, grid.Model.HeaderRows - 1));
            grid.Model.InvalidateVisual();
        }

        private void Model_QueryCellInfo(object sender, GridQueryCellInfoEventArgs e)
        {
            //Modify the background of header cells based on cell selection.
            if ((e.Cell.RowIndex == grid.Model.HeaderRows - 1 && grid.Model.SelectedRanges.AnyRangeIntersects(GridRangeInfo.Col(e.Cell.ColumnIndex)))
                || (e.Cell.ColumnIndex == grid.Model.HeaderColumns - 1 && grid.Model.SelectedRanges.AnyRangeIntersects(GridRangeInfo.Row(e.Cell.RowIndex))))
            {
                e.Style.Background = new SolidColorBrush(Colors.DarkOrange);
            }

            if (e.Cell.RowIndex == 0 && e.Cell.ColumnIndex == 0)
                return;
            if (e.Cell.RowIndex == 0)
                e.Style.CellValue = GridRangeInfo.GetAlphaLabel(e.Cell.ColumnIndex);
            else if(e.Cell.ColumnIndex == 0)
                e.Style.CellValue = e.Cell.RowIndex;
        }
    }
}
